-- Super Mindcrack Bros Entities --
-- RWL --

entity = {}

zombiespeed = 4

particleimg = love.graphics.newImage("graphics/portalparticle.png")
particles = love.graphics.newParticleSystem(particleimg,2000)
particles:setEmissionRate(10)
particles:setParticleLifetime(3)
particles:setDirection(3*math.pi/2)
particles:setSpread(math.pi/2)
particles:setSpeed(40,60)
particles:setColors(255,0,255,255)
particles:start()

function drawEntities(ground)
	for k,v in pairs (entity) do
		if v.id == "cloud" and mapB == 1 and ground == -1 then
			love.graphics.setColor(255,255,255,170)
			love.graphics.rectangle("fill",v.x*scale-camx()/2,v.y*scale-camy(),v.w*scale,v.h*scale)
			
		elseif v.id == "block" and ground == 0 then
			love.graphics.setColor(200,200,200)
			love.graphics.draw(tilesimg,tilesquad[v.tile],math.floor(v.x*scale-camx()),math.floor(v.y*scale-camy()),0,scale/tileWidth,scale/tileWidth)
			
		elseif v.id == "coin" and ground == 0 then
			love.graphics.setColor(255,255,255)
			love.graphics.draw(tilesimg,tilesquad[coinimg],math.floor((v.x+(1-v.w)/2)*scale-camx()),math.floor(v.y*scale-camy()),0,scale/tileWidth*v.w,scale/tileWidth)
			
		elseif v.id == "zombie" and ground == 1 and v.ma == mapA and v.mb == mapB then
			love.graphics.setColor(200,200,200)
			if v.dir == 1 then
				love.graphics.draw(zombieimg,playerquad[v.q],v.x-camx()-8*personscale,v.y-camy()-8*personscale,0,personscale,personscale)
			else
				love.graphics.draw(zombieimg,playerquad[v.q],v.x-camx()+8*personscale,v.y-camy()-8*personscale,0,-personscale,personscale)
			end
			drawHat(v.x,v.y,v.dir,v.q,"zombie")
		elseif v.id == "creeper" and ground == 1 and v.ma == mapA and v.mb == mapB then
			love.graphics.setColor(200,200,200)
			if v.dir == 1 then
				love.graphics.draw(creeperimg,playerquad[v.q],v.x-camx()-8*personscale,v.y-camy()-8*personscale,0,personscale,personscale)
			else
				love.graphics.draw(creeperimg,playerquad[v.q],v.x-camx()+8*personscale,v.y-camy()-8*personscale,0,-personscale,personscale)
			end
			drawHat(v.x,v.y,v.dir,v.q,"creeper")
			
		elseif v.id == "person" and ground == v.ground and v.ma == mapA and v.mb == mapB then
			if class ~= v.name then
				love.graphics.setColor(200,200,200)
				if player.x < v.x then
					love.graphics.draw(playerimg[v.name],playerquad[1],v.x+8*personscale-camx(),v.y-16*personscale-camy(),0,-personscale,personscale)
				elseif v.name == "etho" or v.name == "docm" or v.name == "kurt" or v.name == "zisteau" then
					love.graphics.draw(playerimg[v.name],playerquad[7],v.x-8*personscale-camx(),v.y-16*personscale-camy(),0,personscale,personscale)
				else
					love.graphics.draw(playerimg[v.name],playerquad[1],v.x-8*personscale-camx(),v.y-16*personscale-camy(),0,personscale,personscale)
				end
			end
			
		end
	end
	
	love.graphics.setColor(255,255,255)
	
	if mapA == 1 and mapB == 1 then
		if ground == 0 and class ~= "beef" then
			love.graphics.setColor(200,200,200)
			love.graphics.draw(playerimg["beef"],playerquad[7],99*scale-camx(),18.1*scale-camy(),-0.3,personscale,personscale)
			love.graphics.draw(legimg,100.6*scale-camx(),18.75*scale-camy(),0,-personscale,personscale)
			love.graphics.draw(legimg,101*scale-camx(),18.75*scale-camy(),0,personscale,personscale)
			love.graphics.setColor(255,255,255)
			marioprint("controls:",4*scale-camx()/1.5,140,2)
			marioprint("move - "..control["Left"]..","..control["Right"],4*scale-camx()/1.5,170,2)
			marioprint("down - "..control["Down"],4*scale-camx()/1.5,200,2)
			if control["Jump"] == " " then
				marioprint("jump - space",4*scale-camx()/1.5,230,2)
			else
				marioprint("jump - "..control["Jump"],4*scale-camx()/1.5,230,2)
			end
			marioprint("sprint - "..control["Sprint"],4*scale-camx()/1.5,260,2)
		end
		
	elseif mapA == 4 and mapB == 2 then
		if ground == 1 then
			marioprint("remember, use "..control["Sprint"].." to sprint!",10*scale-camx()/1.5,140,2)
		end
		
	elseif mapA == 6 and mapB == 2 then
		if ground == 1 then
			love.graphics.translate(-camx(),-camy())
			particles:setPosition(78.5*scale,16*scale)
			love.graphics.draw(particles)
			love.graphics.translate(camx(),camy())
			
			love.graphics.draw(tilesimg,tilesquad[22],math.floor(77*scale-camx()),math.floor(15*scale-camy()),0,scale/tileWidth,scale/tileWidth)
			love.graphics.draw(tilesimg,tilesquad[22],math.floor(78*scale-camx()),math.floor(15*scale-camy()),0,scale/tileWidth,scale/tileWidth)
			love.graphics.draw(tilesimg,tilesquad[22],math.floor(79*scale-camx()),math.floor(15*scale-camy()),0,scale/tileWidth,scale/tileWidth)
			love.graphics.draw(tilesimg,tilesquad[-5],math.floor(77*scale-camx()),math.floor(16*scale-camy()),0,scale/tileWidth,scale/tileWidth)
			love.graphics.draw(tilesimg,tilesquad[-5],math.floor(78*scale-camx()),math.floor(16*scale-camy()),0,scale/tileWidth,scale/tileWidth)
			love.graphics.draw(tilesimg,tilesquad[-5],math.floor(79*scale-camx()),math.floor(16*scale-camy()),0,scale/tileWidth,scale/tileWidth)
			
			if player.x > 64*scale-8*playerscale and player.dir == 1 and class ~= "herobrine" then
				love.graphics.draw(herobrineskin,61*scale-8*personscale-camx(),19*scale-16*personscale-camy(),0,personscale,personscale)
			end
		end
		
	end
	
	-- Flag --
	if ground == 0 and mapB == flagm and flag then
		love.graphics.setColor(200,200,200)
		love.graphics.draw(flagimg,getDrawX(flagx,flagr,45*2*scale/tileWidth,(flagimg:getHeight()-8)*2*scale/tileWidth)-camx(),getDrawY(18.5*scale,flagr,45*2*scale/tileWidth,(flagimg:getHeight()-8)*2*scale/tileWidth)-camy(),flagr,scale/tileWidth,scale/tileWidth)
	end
	
end

function drawHat(x,y,dir,q,class)
	if class ~= "dinnerbone" and class ~= "millbee" and class ~= "seth" and os.date("%m") == "12" and tonumber(os.date("%d")) >= 18 then
		if q == 2 or q == 4 or q == 6 then
			haty = 10
		elseif q == 7 then
			haty = 1
		else
			haty = 9
		end
		if dir == 1 then
			love.graphics.draw(santahatimg,x-camx()-8*personscale,y-camy()-haty*personscale,0,personscale,personscale)
		else
			love.graphics.draw(santahatimg,x-camx()+8*personscale,y-camy()-haty*personscale,0,-personscale,personscale)
		end
	end
end

function drawPoints()
	love.graphics.setColor(255,255,255)
	for k,v in pairs (entity) do
		if v.id == "text" then
			marioprint(v.text,v.x,v.y,scale/25)
		end
	end
end

function updateEntities(dt)
	for k,v in pairs (entity) do
		if v.id == "block" then
			if love.timer.getTime() > v.t + 0.2 then
				setTile(v.x,v.oldy,v.tile)
				table.remove(entity,k)
			elseif love.timer.getTime() > v.t + 0.1 then
				v.y = v.y + 5 * dt
				if v.tile == 4 or v.tile == 20 then
					v.tile = 3
				end
			else
				v.y = v.y - 5 * dt
			end
			
		elseif v.id == "coin" then
			if love.timer.getTime() > v.t + 0.3 then
				table.remove(entity,k)
			else
				v.y = v.y - 8 * dt
				v.w = v.w - 5 * dt
			end
			
		elseif v.id == "text" then
			if love.timer.getTime() > v.t + 0.7 then
				table.remove(entity,k)
			else
				v.y = v.y - 4 * scale * dt
			end
		
		elseif (v.id == "zombie" or v.id == "creeper") and v.ma == mapA and v.mb == mapB and not dead then
			if not v.dead then
				if v.x < player.x + personscale*10 and v.x > player.x - personscale*10 and v.y < player.y + personscale*15 then
					if v.y > player.y - personscale*8 and player.vy > 0 then
						v.q = 7
						v.dead = true
						v.deathtick = love.timer.getTime()
						player.vy = -10
						animateText("100",player.x/scale,player.y/scale)
						points = points + 100
						playSound(sound.stomp)
					elseif v.y > player.y - personscale*15 then
						if class ~= v.id then
							die(true)
							if v.id == "creeper" then
								playSound(sound.explode)
							end
						end
					end
				end
				if checkTilesX(v.x + (zombiespeed*v.dir) * scale * dt,v.y-1,16*personscale) or not checkTilesX(v.x +((zombiespeed+16*personscale)*v.dir)*scale*dt,v.y+scale,16*personscale) then
					v.dir = -v.dir
				else
					v.x = v.x + (zombiespeed*v.dir) * scale * dt
				end
				v.vy = v.vy + 65 * dt
				if checkTilesY(v.x,v.y + v.vy * scale * dt,16*personscale) then
					v.vy = 0
					v.y = math.floor(v.y/scale)*scale + (scale-8*personscale)
				else
					v.y = v.y + v.vy
				end
				
				if love.timer.getTime() > v.walktick + 0.15 and not v.dead then
					v.walktick = love.timer.getTime()
					if v.q == 2 then
						v.q = 3
					elseif v.q == 3 then
						v.q = 4
					elseif v.q == 4 then
						v.q = 5
					else
						v.q = 2
					end
				end
			else
				if love.timer.getTime() > v.deathtick + 0.4 then
					table.remove(entity,k)
				end
			end
			
		elseif v.id == "person" then
			if v.name == "zisteau" and mapA == 4 then
				if v.y > 19.6 * scale then
					v.vy = -1
				elseif v.y < 19.4 * scale then
					v.vy = 1
				end
				v.y = v.y + v.vy * 4 * dt
			end
			
		end
		
	end
	
	if animateflag then
		flagr = flagr + 1.5 * dt
		if flagr > math.pi/2 then
			animateflag = false
			playSound(sound.crash)
		end
	end
end

function addMapEntities()
	entity = {}
	
	if mapA ~= 7 then
		table.insert(entity,{id="cloud",x=10,y=6,w=5.5,h=2.5})
		table.insert(entity,{id="cloud",x=30,y=7.5,w=5.5,h=2.5})
		table.insert(entity,{id="cloud",x=60,y=7,w=5.5,h=2.5})
	end
	
	if mapA == 1 then
		player.y=10*scale
		if class == "bdubs" then
			playSound(sound.bdubsholdon)
		end
		table.insert(entity,{id="zombie",x=52*scale,y=18*scale,vy=0,dir=1,q=1,walktick=0,ma=mapA,mb=1})
		table.insert(entity,{id="person",name="vechs",x=9*scale,y=19*scale,ma=mapA,mb=2,ground=1})
		
	elseif mapA == 2 then
		table.insert(entity,{id="creeper",x=90*scale,y=18*scale,vy=0,dir=1,q=1,walktick=0,ma=mapA,mb=1})
		table.insert(entity,{id="person",name="etho",x=43.5*scale,y=18.5*scale,ma=mapA,mb=1,ground=0})
		table.insert(entity,{id="person",name="pakratt",x=12.5*scale,y=13*scale,ma=mapA,mb=2,ground=0})
		
	elseif mapA == 3 then
		table.insert(entity,{id="zombie",x=75*scale,y=18*scale,vy=0,dir=1,q=1,walktick=0,ma=mapA,mb=1})
		table.insert(entity,{id="zombie",x=77*scale,y=18*scale,vy=0,dir=1,q=2,walktick=0,ma=mapA,mb=1})
		table.insert(entity,{id="person",name="baj",x=64*scale,y=13*scale,ma=3,mb=1,ground=0})
		table.insert(entity,{id="person",name="baj",x=67*scale,y=13*scale,ma=3,mb=1,ground=0})
		
	elseif mapA == 4 then
		table.insert(entity,{id="zombie",x=73*scale,y=15*scale,vy=0,dir=1,q=2,walktick=0,ma=mapA,mb=1})
		table.insert(entity,{id="zombie",x=43*scale,y=18*scale,vy=0,dir=1,q=2,walktick=0,ma=mapA,mb=2})
		table.insert(entity,{id="person",name="arkas",x=33.5*scale,y=10*scale,ma=mapA,mb=1,ground=0})
		table.insert(entity,{id="person",name="zisteau",x=50*scale,y=19*scale,ma=mapA,mb=2,ground=-1,vy=1})
		
	elseif mapA == 5 then
		table.insert(entity,{id="zombie",x=60*scale,y=15*scale,vy=0,dir=1,q=2,walktick=0,ma=mapA,mb=1})
		table.insert(entity,{id="zombie",x=60*scale,y=15*scale,vy=0,dir=-1,q=1,walktick=0,ma=mapA,mb=1})
		table.insert(entity,{id="creeper",x=70*scale,y=15*scale,vy=0,dir=-1,q=3,walktick=0,ma=mapA,mb=1})
		table.insert(entity,{id="zombie",x=10*scale,y=15*scale,vy=0,dir=1,q=3,walktick=0,ma=mapA,mb=2})
		table.insert(entity,{id="person",name="kurt",x=54*scale,y=15*scale,ma=mapA,mb=1,ground=0})
		table.insert(entity,{id="person",name="nebris",x=14*scale,y=19*scale,ma=mapA,mb=2,ground=1})
		
	elseif mapA == 6 then
		flag = false
		particles:setPosition(78.5*scale-camx(),11*scale)
		table.insert(entity,{id="zombie",x=18*scale,y=18*scale,vy=0,dir=1,q=1,walktick=0,ma=mapA,mb=2})
		table.insert(entity,{id="creeper",x=34*scale,y=14*scale,vy=0,dir=1,q=1,walktick=0,ma=mapA,mb=2})
		table.insert(entity,{id="person",name="mhykol",x=39*scale,y=17*scale,ma=mapA,mb=1,ground=1})
		
	elseif mapA == 7 then
		flag = false
		player.x = 4.5 * scale
		player.y = 19 * scale
		table.insert(entity,{id="zombie",x=30*scale,y=15*scale,vy=0,dir=1,q=1,walktick=0,ma=mapA,mb=1})
		table.insert(entity,{id="creeper",x=78*scale,y=17*scale,vy=0,dir=1,q=1,walktick=0,ma=mapA,mb=1})
		table.insert(entity,{id="zombie",x=11*scale,y=15*scale,vy=0,dir=1,q=1,walktick=0,ma=mapA,mb=2})
		table.insert(entity,{id="person",name="guude",x=32.5*scale,y=10*scale,ma=mapA,mb=1,ground=0})
		table.insert(entity,{id="person",name="docm",x=16*scale,y=19*scale,ma=mapA,mb=2,ground=1})
		
	end
end

function animateBlock(x,y,tile)
	if tile > 0 and (tile == 3 or tile == 4 or tile == 20) then
		if tile == 4 then
			getCoin()
			animateCoin(x,y)
			animateText("200",x,y)
		elseif tile == 20 then
			setTile(x,y-1,-24)
			playSound(sound.cake)
		else
			playSound(sound.blockhit)
		end
		setTile(x,y,0)
		table.insert(entity,{id="block",t=love.timer.getTime(),x=x,y=y,oldy=y,tile=tile})
		for k,v in pairs (entity) do
			if (v.id == "zombie" or v.id == "creeper") and not v.dead and v.x > x*scale-scale/2 and v.x < x*scale + scale + scale/2 then
				v.q = 7
				v.dead = true
				v.deathtick = love.timer.getTime()
				animateText("100",player.x/scale,player.y/scale)
				points = points + 100
				playSound(sound.stomp)
			end
		end
	end
end

function animateCoin(x,y)
	table.insert(entity,{id="coin",t=love.timer.getTime(),x=x,y=y,w=1})
end

function animateText(text,x,y)
	table.insert(entity,{id="text",t=love.timer.getTime(),x=x*scale-camx(),y=y*scale-camy(),text=text})
end

function collideTileEntity(x,y)
	if getTileIn(x,y) == -6 then
		setTile(math.floor(x/scale),math.floor(y/scale),0)
		getCoin()
	elseif getTileIn(x,y) == -24 then
		setTile(math.floor(x/scale),math.floor(y/scale),0)
		animateText("1000",x/scale,y/scale)
		points = points + 1000
		playSound(sound.eat)
		playerscale = scale/10
		big = true
	end
end