-- Super Mindcrack Graphics --
-- RWL --

love.graphics.setDefaultFilter("nearest","nearest")

tileWidth = 16
tilesimg = love.graphics.newImage("graphics/tiles.png")
tilesquad = {}
for f = 0,30 do
	tilesquad[f+1] = love.graphics.newQuad(f*17,0,tileWidth,tileWidth,tilesimg:getWidth(),tilesimg:getHeight())
end
for f = 0,30 do
	tilesquad[-1-f] = love.graphics.newQuad(f*17,17,tileWidth,tileWidth,tilesimg:getWidth(),tilesimg:getHeight())
end

lavaimg = love.graphics.newImage("graphics/lava.png")
lavaquad = {}
for f = 0,9 do
	lavaquad[f+1] = love.graphics.newQuad(f*17,0,16,16,lavaimg:getWidth(),lavaimg:getHeight())
end

endbg = love.graphics.newImage("graphics/endbg.png")

function loadChar(name)
	table.insert(char,{n=name,x=charx,y=chary})
	if chary > 400 then
		charx = charx + 114
	else
		charx = charx + 100
	end
	if charx > 400 then
		charx = -400
		chary = chary + 130
	end
end

function reloadCharacters()
	char = {}
	charx = -400
	chary = 100
	playerimg = {}

	files = love.filesystem.getDirectoryItems("graphics/skins")
	for k,v in pairs (files) do
		if v:find(".png") and love.filesystem.isFile("graphics/skins/"..v) then
			playerimg[v:gsub(".png","")] = love.graphics.newImage("graphics/skins/"..v)
			loadChar(v:gsub(".png",""))
		end
	end
	if completed then
		files = love.filesystem.getDirectoryItems("graphics/skins/extra")
		for k,v in pairs (files) do
			if v:find(".png") and love.filesystem.isFile("graphics/skins/extra/"..v) then
				playerimg[v:gsub(".png","")] = love.graphics.newImage("graphics/skins/extra/"..v)
				loadChar(v:gsub(".png",""))
			end
		end
	end
end
reloadCharacters()

playerquad = {}
for f = 0,11 do
	playerquad[f+1] = love.graphics.newQuad(0,f*17,16,16,16,203)
end
cubecodedskin = love.graphics.newImage("graphics/cubecoded.png")
domainsaxeskin = love.graphics.newImage("graphics/domainsaxe.png")
herobrineskin = love.graphics.newImage("graphics/herobrine.png")

btnimg = {}
files = love.filesystem.getDirectoryItems("graphics/GUI")
for k,v in pairs (files) do
	if v:find(".png") and love.filesystem.isFile("graphics/GUI/"..v) then
		btnimg[v:gsub(".png","")] = love.graphics.newImage("graphics/GUI/"..v)
	end
end

addButton("start",resx/2,resy/2-100,"menu","Start Game")
addButton("character",resx/2,resy/2-30,"menu","Select Character")
addButton("settings",resx/2,resy/2+40,"menu","Settings")
addButton("about",resx/2,resy/2+110,"menu","About")
addButton("exit",resx/2,resy/2+180,"menu","Exit")
addButton("back1",resx/2,resy-70,"character","Back")
if onWindows then
	addButton("channel",resx/2,110,"about","Our YouTube Channel")
	addButton("video",resx/2,230,"about","Watch Original Video")
end
addButton("back2",resx/2,resy-70,"about","Back")
addButton("back3",resx/2,resy-70,"settings","Back")
addButton("fullscreen",resx/2,100,"settings","Toggle Fullscreen")
addButton("volume",resx/2,150,"settings","Volume",true)
addButton("end",resx/2,resy-100,"complete","Done")

sliderimg = love.graphics.newImage("graphics/GUI/slider.png")
flagimg = love.graphics.newImage("graphics/entities/flag.png")
legimg = love.graphics.newImage("graphics/entities/leg.png")
logoimg = love.graphics.newImage("graphics/logo.png")
zombieimg = love.graphics.newImage("graphics/entities/zombie.png")
creeperimg = love.graphics.newImage("graphics/entities/creeper.png")
santahatimg = love.graphics.newImage("graphics/entities/santahat.png")

potatostickimg = love.graphics.newImage("graphics/potatostick.png")
axeimg = love.graphics.newImage("graphics/diamond_axe.png")

splashtext = {}
for f = 1,4 do
	splashtext[f] = love.graphics.newImage("graphics/GUI/splashtext"..f..".png")
end

fontimage = love.graphics.newImage("graphics/font.png")
fontglyphs = "0123456789abcdefghijklmnopqrstuvwxyz.:/,'C-_>* !{}?"
fontquads = {}
for i = 1, string.len(fontglyphs) do
	fontquads[string.sub(fontglyphs, i, i)] = love.graphics.newQuad((i-1)*8, 0, 8, 8, 512, 8)
end
buttonimg = love.graphics.newImage("graphics/GUI/buttons.png")
buttonq1 = love.graphics.newQuad(0,0,147,20,147,62)
buttonq2 = love.graphics.newQuad(0,21,147,20,147,62)
buttonq3 = love.graphics.newQuad(0,42,147,20,147,62)
mcfontimage = love.graphics.newImage("graphics/GUI/mcfont.png")
fontglyphs = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz:. "
mcfontquads = {}
for i = 1, string.len(fontglyphs) do
	mcfontquads[string.sub(fontglyphs, i, i)] = love.graphics.newQuad((i-1)*6, 0, 5, 8, 400, 8)
end

function marioprint(s, x, y, sc)
	for i = 1, string.len(tostring(s)) do
		local c = string.sub(s, i, i)
		if fontquads[c] then
			love.graphics.draw(fontimage, fontquads[c], x+((i-1)*8)*sc, y, 0, sc, sc)
		end
	end
end
function mcprint(s, x, y, sc)
	for i = 1, string.len(tostring(s)) do
		local c = string.sub(s, i, i)
		if mcfontquads[c] then
			love.graphics.draw(mcfontimage,mcfontquads[c],x,y,0,sc,sc)
		end
		if c == "i" or c == ":" or c == "." then
			x = x+2*sc
		elseif c == "l" then
			x = x+3*sc
		elseif c == "I" or c == "t" then
			x = x+4*sc
		elseif c == "f" or c == "k" or c == " " then
			x = x+5*sc
		else
			x = x+6*sc
		end
	end
end

function textLength(s)
	local l = 0
	for i = 1,#s do
		local char = string.sub(s,i,i)
		if char == "i" or char == ":" or char == "." then
			l = l + 2
		elseif char == "l" then
			l = l + 3
		elseif char == "I" or char == "t" then
			l = l + 4
		elseif char == "f" or char == "k" or char == " " then
			l = l + 5
		else
			l = l + 6
		end
	end
	return l
end
function drawMCText(s,x,y,sc,t)
	love.graphics.setColor(56,56,56,255)
	mcprint(s,x+sc,y+sc,sc)
	if t then
		love.graphics.setColor(255,255,255,255)
	else
		love.graphics.setColor(255,255,160,255)
	end
	mcprint(s,x,y,sc)
end
function drawButton(s,x,y,sc,slider)
	local xmax = x+sc*147
	local ymax = y+sc*20
	mx,my = love.mouse.getPosition()
	local over = false
	love.graphics.setColor(255,255,255)
	if mx > x and my > y and mx < xmax and my < ymax and not paused then
		over = true
		if slider then
			love.graphics.draw(buttonimg,buttonq3,x,y,0,sc,sc)
		else
			love.graphics.draw(buttonimg,buttonq2,x,y,0,sc,sc)
		end
		drawMCText(s,x-(textLength(s)/2*sc)+(xmax/2)-x/2,y+10*sc-4*sc,sc,false)
	else
		over = false
		if slider then
			love.graphics.draw(buttonimg,buttonq3,x,y,0,sc,sc)
		else
			love.graphics.draw(buttonimg,buttonq1,x,y,0,sc,sc)
		end
		drawMCText(s,x-(textLength(s)/2*sc)+(xmax/2)-x/2,y+10*sc-4*sc,sc,true)
	end
	return over
end