-- Super Mindcrack Bros --
-- Made by CubeCoded (Daniel Kruger) --
-- Feel free to use any of my code in your own projects --
-- If you claim this game as your own... I will find you --

if love.system.getOS() == "Windows" then
	onWindows = true
end
debugstr = 0
modes = love.window.getFullscreenModes()
resx = modes[1].width
-- resx = 1100
-- resx = 1920
resy = modes[1].height
-- resy = 600
-- resy = 1080
scale = math.ceil(resx/25)
playerscale = scale/12
personscale = scale/12
love.window.setTitle("Super Mindcrack Bros")
love.window.setIcon(love.image.newImageData("graphics/icon.png"))

require "functions"
require "sound"
require "settings"
require "graphics"
require "player"
require "pipe"
require "map"
require "entities"
require "GUI"
require "events"

paused = false
debugmode = false
firstmap = 1
lastmap = 7

oldmx = love.mouse.getX()
oldmy = love.mouse.getY()
mousetick = love.timer.getTime()

function love.draw()
	if mode == "game" then
		drawEntities(-1)
		drawMap(0)
		drawEntities(0)
		drawPlayer()
		drawMap(1)
		drawEntities(1)
		drawPoints()
	end
	drawGUI()
	
	if debugmode then
		love.graphics.setColor(255,255,255)
		love.graphics.print("FPS: "..love.timer.getFPS(),0,100)
		if player and player.x then
			love.graphics.print("Player Coords: "..player.x/scale.." , "..player.y/scale,0,120)
		end
		if mode == "game" then
			love.graphics.print("Camera: "..camx().." , "..camy(),0,140)
		end
		love.graphics.print("Tiles Rendered: "..tilesrendered,0,160)
		love.graphics.print("Debug: "..tostring(debugstr),0,180)
		love.graphics.print("Mode: "..mode,0,200)
	end
end

function love.update(dt)
	if not paused and dt < 0.3 then
		if mode == "game" or mode == "gameover" or mode == "complete" then
			updatePlayer(dt)
			updatePipes(dt)
			updateEntities(dt)
			checkEvents(dt)
			particles:update(dt)
			
			if love.mouse.getX() ~= oldmx or love.mouse.getY() ~= oldmy then
				mousetick = love.timer.getTime()
				oldmx = love.mouse.getX()
				oldmy = love.mouse.getY()
				love.mouse.setVisible(true)
			elseif love.timer.getTime() > mousetick + 3 then
				mousetick = love.timer.getTime()
				love.mouse.setVisible(false)
			end
			
			if debugmode then
				if love.keyboard.isDown("up") then
					player.y = player.y - 700 * dt
					player.vy = 0
					player.q = 6
				end
				if love.keyboard.isDown("right") then
					player.x = player.x + 800 * dt
				end
				if love.keyboard.isDown("left") then
					player.x = player.x - 800 * dt
				end
			end
			
		end
		updateGUI(dt)
	end
	
end

function love.keypressed(k,u)
	if enterkey then
		if k == "escape" then
			enterkey = false
		else
			control[enterkey] = k
			if k == " " then k = "space" end
			btn["control"..enterkey].name = enterkey..": "..k
			enterkey = false
		end
	else
		if k == "escape" then
			if mode == "menu" then
				love.event.quit()
			elseif mode ~= "complete" then
				mode = "menu"
				love.mouse.setVisible(true)
				for k,v in pairs (sound) do
					love.audio.stop(v)
				end
			end
		elseif k == "f2" then
			love.graphics.newScreenshot():encode("screenshot.png")
		elseif k == "f3" then
			-- debugmode = not debugmode
		elseif k == "f11" then
			fullscreen = not fullscreen
			love.window.setMode(resx,resy,{fullscreen=fullscreen})
		end
	end
end

function love.mousepressed(x,y,b)
	if b == "l" then
		menuClick(x,y)
	end
end

function love.mousereleased(x,y,b)
	if b == "l" then
		menuUnClick(x,y)
	end
end

function love.focus(f)
	paused = not f
end

function love.quit()
	Settings.save()
end