-- Super Mindcrack Bros Map --
-- RWL --

tilesrendered = 0
map = {}

function readmap(a,b)
	if not map[a] then
		map[a] = {}
	end
	if not map[a][b] then
		map[a][b] = {}
	end
	if love.filesystem.isFile("maps/"..a.."-"..b..".png") then
		mapdat = love.image.newImageData("maps/"..a.."-"..b..".png")
		mapA = a
		mapB = b
		
		mapheight = mapdat:getHeight()
		mapwidth = mapdat:getWidth()
		
		for y = 1,mapheight do
			for x = 1,mapwidth do
				r,g,b,a = mapdat:getPixel(x-1,y-1)
				if a == 0 then
					r = 0
				end
				if g == 255 then
					r = -r
				end
				setTile(x,y,r)
			end
		end
	else
		os.execute("pause")
	end
end

function loadmap(a,b)
	mapA = a
	mapB = b
	
	player.vx=0
	player.vy=0
	player.ax=0
	player.dir=1
	onground = false
	love.audio.stop(sound.overworld)
	love.audio.stop(sound.underworld)
	love.audio.stop(sound.castle)
	
	-- if mode == "game" then
		if a == 7 then
			love.graphics.setBackgroundColor(0,0,0)
			playSound(sound.castle)
		else
			if b == 1 then
				love.graphics.setBackgroundColor(70,100,255)
				playSound(sound.overworld)
			elseif b == 2 then
				playSound(sound.underworld)
				love.graphics.setBackgroundColor(0,0,0)
			elseif b == 3 then
				playSound(sound.castle)
				love.graphics.setBackgroundColor(50,0,0)
			end
		end
	-- end
end

function drawMap(ground)
	fxmin = math.floor(camx()/scale)
	fxmax = math.floor(camx()/scale+resx/scale)
	fymin = math.floor(camy()/scale)
	fymax = math.floor(camy()/scale+resy/scale)
	
	if ground == 0 and mapA == lastmap then
		for fx = 0,resx/scale do
			for fy = 0,resy/scale do
				love.graphics.draw(endbg,fx*scale,fy*scale,0,scale/tileWidth/3,scale/tileWidth/3)
			end
		end
	end
	
	-- tilesrendered = 0
	love.graphics.setColor(210,210,210)
	for fy = fymin,fymax do
		for fx = fxmin,fxmax do
			if getTile(fx,fy) ~= 0 and (getTile(fx,fy) < 0 and ground == 0) or (getTile(fx,fy) > 0 and ground == 1) then
				if getTile(fx,fy) == -6 then
					love.graphics.draw(tilesimg,tilesquad[coinimg],math.floor(fx*scale-camx()),math.floor(fy*scale-camy()),0,scale/tileWidth,scale/tileWidth)
				elseif getTile(fx,fy) == -19 then
					love.graphics.draw(lavaimg,lavaquad[lava],math.floor(fx*scale-camx()),math.floor(fy*scale-camy()),0,scale/tileWidth,scale/tileWidth)
				else
					love.graphics.draw(tilesimg,tilesquad[getTile(fx,fy)],math.floor(fx*scale-camx()),math.floor(fy*scale-camy()),0,scale/tileWidth,scale/tileWidth)
				end
				-- tilesrendered = tilesrendered + 1
			end
		end
	end
end

function updateMap(dt)
	
end

function camx()
	return math.max(math.min(player.x - resx/2 + 50, #map[mapA][mapB][1]*scale-resx),scale)
end

function camy()
	return 20.5*scale - resy
end

function getTileIn(x,y)
	if type(map[mapA][mapB][math.floor(y/scale)]) == "nil" then
		return 0
	elseif type(map[mapA][mapB][math.floor(y/scale)][math.floor(x/scale)]) == "nil" then
		return 0
	end
	return map[mapA][mapB][math.floor(y/scale)][math.floor(x/scale)].tile
end

function getTile(x,y)
	if type(map[mapA][mapB][y]) == "nil" then
		return 0
	elseif type(map[mapA][mapB][y][x]) == "nil" then
		return 0
	end
	return map[mapA][mapB][y][x].tile
end

function setTile(x,y,t)
	if type(map[mapA][mapB][y]) == "nil" then
		map[mapA][mapB][y] = {}
	end
	if not map[mapA][mapB][y][x] then
		map[mapA][mapB][y][x] = {}
	end
	map[mapA][mapB][y][x].tile = t
end

function checkTilesX(x,y,w)
	collide = false
	for f=y-w/2,y+w/2,scale do
		if getTileIn(x+w/2,f) > 0 or getTileIn(x-w/2,f) > 0 then
			collide = true
			break
		end
	end
	if getTileIn(x+w/2,y+w/2) > 0 or getTileIn(x-w/2,y+w/2) > 0 then collide = true end
	
	return collide
end

function checkTilesY(x,y,w)
	collide = false
	for f=x-w/2,x+w/2,scale do
		if getTileIn(f,y+w/2) > 0 or getTileIn(f,y-w/2) > 0 then
			collide = true
			break
		end
	end
	if getTileIn(x+w/2,y+w/2) > 0 or getTileIn(x+w/2,y-w/2) > 0 then collide = true end
	
	return collide
end

function readMaps()
	for f=1,7 do
		readmap(f,1)
		readmap(f,2)
	end
	readmap(4,3)
	mapA = 0
	mapB = 0
end