-- Super Mindcrack Bros Player Functions --
-- RWL --

player = {}
walktick = 0
deathtick = 0
speed = 0
onground = false
jumptick = 0
inpipe = false
hitflash = false
hittimer = 0
hitshow = true
hitnblink = 0


function drawPlayer()
	
	love.graphics.setColor(200,200,200)
	if hitshow then --Flash when hit
		if inpipe == "down" then
			x = math.round(player.x/scale,0)*scale
		else
			x = player.x
		end
		if player.dir == 1 then
			love.graphics.draw(playerimg[class],playerquad[player.q],x-camx()-16*playerscale/2,player.y-camy()-18*playerscale/2,0,playerscale,playerscale)
		else
			if class == "etho" or class == "docm" or class == "kurt" or class == "zisteau" then
				love.graphics.draw(playerimg[class],playerquad[player.q+6],x-camx()+16*playerscale/2,player.y-camy()-18*playerscale/2,0,-playerscale,playerscale)
			else
				love.graphics.draw(playerimg[class],playerquad[player.q],x-camx()+16*playerscale/2,player.y-camy()-18*playerscale/2,0,-playerscale,playerscale)
			end
		end
		drawHat(x,player.y,player.dir,player.q,class)
		-- love.graphics.circle("fill",player.x-camx(),player.y-camy(),5)
	end
	-- love.graphics.print("hitshow: "..tostring(hitshow).."\t hitnblink: "..tostring(hitnblink),0,0)
	
end

function updatePlayer(dt)
	
	if not dead and not inpipe then
		
		player.vy = player.vy + 65 * dt
		player.vx = 0
		
		if love.keyboard.isDown(control["Sprint"]) then
			speed = 10
		else
			speed = 7
		end
		
		if love.keyboard.isDown(control["Left"]) and player.x > playerscale*8+scale and not won then
			player.vx = player.vx - speed
			player.dir = -1
		end
		
		if love.keyboard.isDown(control["Right"]) and player.x < #map[mapA][mapB][1]*scale - playerscale*8 and not won then
			player.vx = player.vx + speed
			player.dir = 1
		end
		
		if love.keyboard.isDown(control["Down"]) then
			if getTileIn(player.x+player.vx*scale*dt-scale/2,player.y+10*playerscale) == 7 then
				enterPipe("down")
				player.y = math.floor((player.y+player.vy*scale*dt)/scale)*scale + (scale-7*playerscale)
			end
		end
		
		if love.keyboard.isDown(control["Jump"]) and not won then
			if onground and love.timer.getTime() > jumptick + 0.3  then
				jumptick = love.timer.getTime()
				-- player.vy = -0.35*scale
				player.vy = -21
				onground = false
				player.q = 6
				playSound(sound.jump)
			end
		elseif player.vy < -10 then
			player.vy = -10
		end
		
		if player.vx ~= 0 then
			if checkTilesX(player.x + player.vx * scale * dt,player.y-1,14*playerscale) then
				if getTileIn(player.x+player.vx*scale*dt+playerscale*8,player.y+player.vy*scale*dt-scale/2) == 12 then
					player.y = player.y+player.vy*scale*dt
					enterPipe("right")
				end
				player.vx = 0
			else
				player.x = player.x + player.vx * scale * dt
			end
		end
		
		if checkTilesY(player.x,player.y + player.vy * scale * dt,14*playerscale) then
			if player.vy > 0 then
				if not onground then
					player.y = math.floor((player.y+player.vy*scale*dt)/scale)*scale + (scale-7*playerscale)
				elseif checkTilesY(player.x,player.y-1,14*playerscale) then
					player.y = math.floor(player.y/scale-1)*scale + (scale-7*playerscale)
				end
				onground = true
			elseif player.vy < 0 then
				player.y = math.floor((player.y+player.vy*scale*dt)/scale)*scale + (8*playerscale)
				if getTileIn(player.x,player.y+player.vy*scale*dt-9*playerscale) ~= 0 then
					animateBlock(math.floor(player.x/scale),math.floor((player.y+player.vy*scale*dt-9*playerscale)/scale),getTileIn(player.x,player.y+player.vy*scale*dt-10*playerscale))
				end
			end
			player.vy = 0
		else
			player.y = player.y + player.vy * scale * dt
			onground = false
		end
		
		if love.timer.getTime() > walktick + 0.1 and onground then
			if player.vx ~= 0 or player.vy ~= 0 or won then
				walktick = love.timer.getTime()
				if player.q == 2 then
					player.q = 3
				elseif player.q == 3 then
					player.q = 4
				elseif player.q == 4 then
					player.q = 5
				else
					player.q = 2
				end
			else
				player.q = 1
			end
		end
		
		collideTileEntity(player.x-0.5*scale,player.y+0.5*scale)
		collideTileEntity(player.x+0.5*scale,player.y+0.5*scale)
		collideTileEntity(player.x-0.5*scale,player.y-0.5*scale)
		collideTileEntity(player.x+0.5*scale,player.y-0.5*scale)
	end
	
	if won and mapA ~= 6 then
		-- if mapA == 7 and player.x < 131 * scale then
			player.x = player.x + 5 * scale * dt
		-- end
	end
	
	--Hit invincibility
	if hittimer < love.timer.getTime() then
		hitflash = false
		hittimer = 0
		hitshow = true
	end
	
	if hitnblink < love.timer.getTime() and hitflash then
		
		hitshow = not hitshow
		hitnblink = love.timer.getTime()+0.10
	end
	
end

function enterPipe(direction)
	inpipe = direction
	pipetick = love.timer.getTime()
	player.vy = 0
	playSound(sound.pipe)
end

function getCoin()
	playSound(sound.coin)
	points = points + 200
	coins = coins + 1
	if coins >= 100 then
		lives = lives + 1
		coins = 0
		playSound(sound.oneup)
	end
end

function die(survive)
	if survive and big and not hitflash then
		big = false
		playerscale = scale/12
		playSound(sound.shrink)
		hitflash = true
		hittimer = love.timer.getTime()+2
	elseif not hitflash then
		big = false
		playerscale = scale/12
		dead = true
		deathtick = love.timer.getTime()
		love.audio.stop(sound.overworld)
		love.audio.stop(sound.underworld)
		love.audio.stop(sound.castle)
		playSound(sound.death)
		lives = lives - 1
	end
end