-- Super Mindcrack Bros Settings --
-- RWL --

love.filesystem.setIdentity("SuperMindcrackBros")

Settings = {}
control = {}

btn = {}
btnwidth = 294
btnheight = 40
function addButton(name,x,y,mode,title,slider)
	if slider then
		btn[name] = {x=x-btnwidth/2,y=y-btnheight/2,m=mode,name=title,slider=true}
	else
		btn[name] = {x=x-btnwidth/2,y=y-btnheight/2,m=mode,name=title,slider=false}
	end
end

function Settings.load()
	if love.filesystem.isFile("settings.cfg") then
		
		str = string.split(love.filesystem.read("settings.cfg"),",")
		
		if str[1] == "false" then
			fullscreen = false
		else
			fullscreen = true
		end
		volume = tonumber(str[2]) or 1
		class = str[3] or "steve"
		
		for k,v in pairs (sound) do
			v:setVolume(volume)
		end
		
		if str[4] == "true" then
			completed = true
		else
			completed = false
		end
		
		highscore = tonumber(str[5])
		
		control["Right"] = str[6]
		control["Left"] = str[7]
		control["Down"] = str[8]
		control["Jump"] = str[9]
		control["Sprint"] = str[10]
		addButton("controlRight",resx/2,300,"settings","Right: "..control["Right"] )
		addButton("controlLeft",resx/2,350,"settings","Left: "..control["Left"] )
		addButton("controlDown",resx/2,400,"settings","Down: "..control["Down"] )
		if control["Jump"] == " " then
			addButton("controlJump",resx/2,450,"settings","Jump: space" )
		else
			addButton("controlJump",resx/2,450,"settings","Jump: "..control["Jump"] )
		end
		addButton("controlSprint",resx/2,500,"settings","Sprint: "..control["Sprint"] )
		
	else
		fullscreen = true
		-- volume = 0.93877
		volume = 0.469385
		for k,v in pairs (sound) do
			v:setVolume(volume)
		end
		class = "bdubs"
		completed = false
		highscore = 0
		
		control["Right"] = "right"
		control["Left"] = "left"
		control["Down"] = "down"
		control["Jump"] = " "
		control["Sprint"] = "lshift"
		addButton("controlRight",resx/2,300,"settings","Right: "..control["Right"] )
		addButton("controlLeft",resx/2,350,"settings","Left: "..control["Left"] )
		addButton("controlDown",resx/2,400,"settings","Down: "..control["Down"] )
		if control["Jump"] == " " then
			addButton("controlJump",resx/2,450,"settings","Jump: space" )
		else
			addButton("controlJump",resx/2,450,"settings","Jump: "..control["Jump"] )
		end
		addButton("controlSprint",resx/2,500,"settings","Sprint: "..control["Sprint"] )
		
		Settings.save()
	end
	
	love.window.setMode(resx,resy,{fullscreen=fullscreen})
end

function Settings.save()
	
	str = tostring(fullscreen)..","..volume..","..class..","..tostring(completed)..","..highscore..","..control["Right"]..","..control["Left"]..","..control["Down"]..","..control["Jump"]..","..control["Sprint"]
	
	love.filesystem.write("settings.cfg",str)
	
end

Settings.load()